﻿Type=StaticCode
Version=0.1
B4J=true
@EndOfDesignText@

Sub Process_Globals
	Private fx As JFX
End Sub
'Find the first Node from it's ID as defined in JavaFX SceneBuilder
Sub FindNodeFromID(Parent As Node,ID As String) As Node
	Dim JO As JavaObject = Parent
	'Dim Scene As JavaObject = JO.RunMethod("getScene",Null)
	Return JO.RunMethod("lookup",Array As Object("#"&ID))
End Sub
'Find the All Nodes with the same ID as defined in JavaFX SceneBuilder
Sub FindAllNodesFromID(Parent As Node,ID As String) As Object()
	Dim PA As JavaObject = Parent
	'Convert to List
	Dim NList As List
	Dim JO As JavaObject = PA.RunMethod("lookupAll",Array As Object("#"&ID))
	NList.Initialize
	Dim Result() As Object = JO.RunMethod("toArray",Null)
	Return Result
End Sub
'Find Nodes with the TAG field value of TAG
'Requires a list of Nodes: For layouts loaded to MainForm.RootPane it is obtainable as 
'
'MainForm.RootPane.GetAllViewsRecursive
Sub FindNodeFromTag(Pane1 As Pane,TAG As String) As Node
	Dim NotFound As Node
	For Each N As Node In Pane1.GetAllViewsRecursive
		If N.TAG = TAG Then Return N
	Next
	Return NotFound
End Sub
'Find All Nodes with the TAG field value of TAG
'Requires a list of Nodes: For layouts loaded to MainForm.RootPane it is obtainable as 
'
'MainForm.RootPane.GetAllViewsRecursive
Sub FindAllNodesFromTag(Pane1 As Pane,TAG1 As Object) As Object()
	Dim Found As List
	Found.Initialize
	For Each N As Node In Pane1.GetAllViewsRecursive
		If (N.TAG = TAG1) Then Found.Add(N)		
	Next
	'Convert the list to an array
	Dim JO As JavaObject=Found
	Dim FoundRes() As Object = JO.RunMethod("toArray",Null)
	'And return it
	Return FoundRes
End Sub
'Redefine the points in Poly
Sub ReDefinePoly(Poly As Node,NewPoints() As Object) As Boolean
	Dim Points As JavaObject
	Dim PO As JavaObject = Poly
	Points = PO.RunMethod("getPoints",Null)
	'Removes all points and adds new ones
	Return(Points.RunMethod("setAll",Array As Object(NewPoints)))
End Sub
'For use within a click callback. From Code we can access the Tag Property directly
Sub GetTag(EventData As MouseEvent) As String
	'Get the target from EventData
	Dim JO As JavaObject = EventData
	Dim Target As Node = JO.RunMethod("getTarget",Null)
	'Return it's Tag
	Return Target.Tag
End Sub
'List all childrend on the given AnchorPane - To the Log
Sub LogChildren(Target As AnchorPane)
	Log("**********")
	Log("Output from:")
	Log("HotspotManager - LogChildren")
	For Each N As Node In Target.GetAllViewsRecursive
		Dim NJO As JavaObject=N
		Log("____________________")
		Log(N)
		Log("Id       :"&NJO.RunMethod("getId",Null)) 
		Log("Code Tag :"&N.Tag)
	Next
	Log("____________________")
	Log("Output finished from:")
	Log("HotspotManager - LogChildren")
	Log ("**********")
End Sub
'Adding Tags to Scene Builder uing a style class TAG:{name}
'This subroutine with extract the Tag and add t to the Nodes Tag field within B4J
'Requires a list of Nodes: For layouts loaded to MainForm.RootPane it is obtainable as 
'
'MainForm.RootPane.GetAllViewsRecursive
Sub ExtractTags(Pane1 As Pane)
	
	For Each N As Node In Pane1.GetAllViewsRecursive
		For Each SC As String In N.StyleClasses
			If SC.ToLowerCase.StartsWith("tag:") Then
				'In anticipation of some objects not having a Tag field put it in a Try/Catch clause
				Try
					N.Tag=SC.SubString(4)
				Catch
					Log("SLUtils ExtractTags : Error assigning Tag to Node :"&N)
				End Try
			End If
		Next
	Next

End Sub